#!/usr/bin/env python
# -*- coding: UTF-8 -*-
"""
Script principal de l'application
"""
from era.noyau.path import *
from os import environ
import socket
environ['PATH'] += ';bin'

def run_application():
    
    import locale, gettext, codecs

    environ['LC_ALL'] = "fr_FR"
    environ['LC_MESSAGES'] = "fr_FR"
    environ['LANG']='fr_FR'
    environ['LANGUAGE']='fr'
    locale.setlocale(locale.LC_ALL, 'fr')
    APP = 'editeur'
    DIR = 'i18n'
    DIR_GTK = 'i18n/fr'
    GLADE_FILE = ERA_DIR+"/interface/editeur.glade"
    RC_FILE = ERA_DIR+"/interface/editeur.rc"
    
    from era.noyau import fwobjects
    from era.noyau.pool import library_store
    from era.ihm import matrix
    from era.noyau.initialize import initialize_app
        
    import gtk.glade
    socket.setdefaulttimeout(5)

    gettext.bindtextdomain (APP, DIR)
    gettext.textdomain (APP)
    # installons la fonction _() dans les builtins
    gettext.install (APP, DIR, unicode=1)

    gtk.glade.bindtextdomain (APP,DIR_GTK)
    gtk.glade.textdomain (APP)

    gtk.rc_parse(RC_FILE)

    # On initialise l'application
    model = initialize_app()

    ctrl = matrix.MatrixManager(GLADE_FILE, model)
    view = matrix.MatrixView(GLADE_FILE, ctrl, model)
    view.show_window()
    
    gtk.main()


run_application()
