# -*- coding: UTF-8 -*-
#!/usr/bin/env python

"""
Tests unitaires de parsing de la lib par défaut
"""
from os.path import join

import autopath
from era.noyau.erreurs import *
from era.noyau.fwobjects import *
from era.noyau.models import *
from era.noyau.initialize import *

from era.noyau.pool import library_store
from era.noyau.models import MatrixModel

    
def test_parse_service():
    """Les services sont disponibles
    """
    serv1 = Service("serv1", "tcp", ['8080'],
                                 "test1", "ce service est un test")
    s_list, g_list = parse_service_file(join(autopath.HERE, "data", "services.xml"))
    library_store.services = s_list
    assert library_store.services[0] == serv1

def test_parse_groupes():
    """Les groupes sont disponibles
    """
    s_list, g_list = parse_service_file(join(autopath.HERE, "data","services.xml"))
    library_store.groups = g_list
    assert library_store.groups[0].id == "groupe1"

def test_matrice_zones():
    """Vérifions que la zone a bien été ajoutée dans la matrice
    """
    zone1 = Zone( "bastion", "100", "127.0.0.1", "0.0.0.0",
             "255.255.255.255", "lo")
    matrix_model = MatrixModel()
    zone_list = parse_zone_file(join(autopath.HERE, "data","zones.xml"))
    matrix_model.add_zone(zone_list[0])
    assert matrix_model.zones[0] == zone1
