# -*- coding: UTF-8 -*-
"""tests unitaires du format xml des zones

# FIXME : tester les regles d'utilisation authentifiée générées 

"""

import autopath, os

from xml.dom.minidom import parseString, parse
from era.noyau import domparsers
from era.noyau.fwobjects import UserGroup
from era.noyau.initialize import parse_firewall_file
from StringIO import StringIO

def test_parse_zone():
    """parse une string xml user"""
    USER_XML = """<user_group name="toto" id="15"/>"""
    doc = parseString(USER_XML)
    z = domparsers.instantiate_user_group_from_dom(doc.firstChild)
    assert z.id == "15"
    assert z.name == "toto"

def test_save_zone():
    """enregistrement en xml d'un user"""
    user = UserGroup("15", "titi")
    fh = StringIO()
    user.save(fh)
    output = fh.getvalue()
    expected = """<user_group name="titi" id="15"/>\n"""
    assert output == expected

def test_parse_users():
    """test du chargement depuis un fichier modele """
    model_file = os.path.join(autopath.HERE, "data", "user_groups.xml")
    zones, flux_list, extremites, services, groups, rules, netbios , ranges, model, user_groups, qos, options = parse_firewall_file(model_file)
    assert flux_list[0].up_directives_list()[0].user_group.id == "10"
    assert flux_list[0].up_directives_list()[0].user_group.name == "eleve"
