#!/usr/bin/env python

import os, shutil, glob
from distutils.core import setup
import py2exe

dist_dir = "era_dist"
if os.path.exists(dist_dir):
    shutil.rmtree(dist_dir)

if os.path.exists("build"):
    shutil.rmtree("build")

opts = {"py2exe": {
    "dist_dir": dist_dir,
    "packages":["gtk","encodings"],
    "optimize":2,
    "includes": "pango, atk, gobject, cairo, pangocairo",
    "dll_excludes": ["iconv.dll","intl.dll","libatk-1.0-0.dll", "libgdk_pixbuf-2.0-0.dll","libgdk-win32-2.0-0.dll",
        "libglib-2.0-0.dll","libgmodule-2.0-0.dll",
        "libgobject-2.0-0.dll","libgthread-2.0-0.dll",
        "libgtk-win32-2.0-0.dll","libpango-1.0-0.dll",
        "libpangowin32-1.0-0.dll","libglade-2.0-0.dll"],
    } 
    } 

setup(name="era",
      options=opts,
      version="1.0",
      description="editeur de regles du pare-feu Amon",
      author="Eole",
      author_email="eole@ac-dijon.fr",
      url="http://eole.orion.education.fr/diffusion",
      packages=['editeur'],
      windows=[{
			"script":'editeur/editeur.py',
			"icon_resources":[(1, "eole.ico")]
		  }],
      data_files=[('modeles', glob.glob('../modeles/*.xml')),
          ('interface', glob.glob('../interface/*')),
          ('lib/defaults', glob.glob('../lib/defaults/*.xml')),
          ('images', glob.glob('../images/*')),
          ('i18n/fr/LC_MESSAGES',  ['../i18n/fr/LC_MESSAGES/editeur.mo']),
          ]
      )
