#!/bin/bash

echoerror()
{
	tput setaf 1
	echo "nok"
	echo $1
	tput sgr0
	exit 1
}

launch_ssh_command()
{
	ipsshcom=$1
	commandlaunchssh=$2
	backgroundssh=$3
	returntext=''
	if [ "$backgroundssh" = "yes" ]; then
		ssh root@$ipsshcom "$commandlaunchssh" &
	else
		returntext=`ssh root@$ipsshcom "$commandlaunchssh"`
	fi
}

init_nufw()
{
	[ ! -x /usr/bin/pwgen ] && echo "installer pwgen" && exit 1
	[ ! -x /bin/netcat ] && echo "installer netcat" && exit 1
	pedago="192.168.235.10"
	bastionpedago="192.168.235.206"
	admin="192.168.231.136"
	bastionadmin="192.168.231.206"
	killall netcat > /dev/null 2> /dev/null
	launch_ssh_command $pedago "killall -q netcat > /dev/null 2> /dev/null"
	launch_ssh_command $admin "killall -q netcat > /dev/null 2> /dev/null"
	echo -n "IPSOURCE      	IPDEST      	PORT	PORTFW	GUEST	ELEVES	PROFS"
}

is_local ()
{
	ifconfig | grep -q $1
}

launch_listen_netcat()
{ 
	is_local $destip
	if [ ! $? = 0 ]; then
		if [ ! $redirectport = '-' ]; then
			[ $redirectport = '-' ] && echoerror "Need forward port"
			netcat -l -p $redirectport -c "/bin/echo '$fwmessage'" 2> /dev/null &
		fi
		launch_ssh_command $destip "netcat -l -p $destport -c \"/bin/echo '$okmessage'\" 2> /dev/null" "yes"
	else
		netcat -l -p $destport -c "/bin/echo '$okmessage'" 2> /dev/null &
	fi
}

disconnect_nutcpc()
{
	launch_ssh_command $srcip "./nutcpc -k > /dev/null 2> /dev/null"
}

connect_nutcpc()
{
	if [ $user = "prof" ]; then
		nuuser=m.gourdin
		nupass=o
	elif [ $user = "eleve" ]; then
		nuuser=leo.bontemps
		nupass=o
	else
		echoerror "unknown group $user"
	fi
	launch_ssh_command $srcip "./nutcpc -U $nuuser -H $ipnufw -P $nupass > /dev/null 2> /dev/null"
	if [ ! $? = 0 ]; then
		echoerror "can't identify $nuuser"
	fi
}

test_connect()
{
	disconnect_nutcpc
	sleep 1
	if [ $srcip = $pedago ]; then
		ipnufw=$bastionpedago
	elif [  $srcip = $admin ]; then
		ipnufw=$bastionadmin
	else
		echoerror "unknown ip for nufw"
	fi
	if [ $user = "eleve" ] || [ $user = "prof" ]; then
		connect_nutcpc
	fi
}

test_port()
{
	returntest=$1
	user=$2
	idmessage=`pwgen 10 1`
	okmessage="nufw rocks $idmessage"
	pbmessage="nufw nok $idmessage"
	fwmessage="nufw redirect $idmessage"
	bugmessage="bug with the script"
	launch_listen_netcat $destport $returntest
	if [ $returntest = 0 ]; then
	       message=$okmessage
	elif [ $returntest = 1 ]; then
	       message=$pbmessage
	elif [ $returntest = 2 ]; then
	       	message=$fwmessage
	else
		echoerror "Unknown return code test (should be 0, 1 or 2) : $returntest"
	fi
	is_local $srcip
	if [ ! $? = 0 ]; then
		test_connect
		launch_ssh_command $srcip "netcat -w 1 $destip $destport 2> /dev/null"
		if [ ! $? = 0 ]; then
			returnnc=`netcat -w 1 $destip $destport 2> /dev/null`
			[ "$returnnc" = "$okmessage" ] && returntext=$pbmessage || returntext=$bugmessage
		fi
	else
		[ ! $user = "non-identifie" ] && echoerror "only non-identifie for localhost"
		sleep 1
		returntext=`netcat -w 1 $destip $destport 2> /dev/null`
		if [ ! $? = 0 ]; then
			returntext=$bugmessage
		fi
	fi
	if [ "$returntext" = "$message" ]; then
		[ $returntest = 0 ] && color="2"
		[ $returntest = 1 ] && color="3"
		[ $returntest = 2 ] && color="6"
		tput setaf $color
		echo -n "ok	"
		tput sgr0
		if [ ! $redirectport = '-' ]; then
			netcat -w 1 localhost $redirectport > /dev/null 2> /dev/null
			netcat -w 1 $destip $destport > /dev/null 2> /dev/null
		fi
	else
		echoerror "prevu : \"$message\" - recu : \"$returntext\""
	fi	
}

test_nufw()
{
	srcip=$1
	destip=$2
	destport=$3
	redirectport=$4
	decnonid=$5
	deceleve=$6
	decprof=$7
	echo
	echo -n "$srcip	$destip	$destport	$redirectport	"
	if [ ! $decnonid = '-' ]; then
		test_port $decnonid "non-identifie"
	else
		echo -n "-	"
	fi
	if [ ! $deceleve = '-' ]; then
		test_port $deceleve "eleve"
	else
		echo -n "-	"
	fi
	if [ ! $decprof = '-' ]; then
		test_port $decprof "prof"
	else
		echo -n "-	"
	fi
}

init_nufw
#test_nufw from    to             toport portfw decisions
#decisions : 0-ACCEPT, 1-DENY, 2-FORWARD for nufwguest, eleves, profs)
test_nufw  $pedago $admin         8500   -      0 1 1
test_nufw  $pedago $admin         194    -      1 0 1
test_nufw  $pedago $admin         195    -      1 - -
test_nufw  $pedago $admin         2009   -      1 0 0

test_nufw  $pedago $admin         2335   3120   1 2 1
test_nufw  $pedago $admin         2338   3120   1 2 1
test_nufw  $pedago $admin         2337   3120   1 2 1

test_nufw  $pedago $bastionpedago 195    -      1 - -
test_nufw  $pedago $bastionpedago 8500   -      1 1 0

test_nufw  $bastionpedago $pedago 195    -      0 - -

test_nufw  $admin  $pedago        2339  3120    2 0 0
test_nufw  $admin  $pedago        2009   -      1 - -
test_nufw  $admin  $pedago        194    -      1 0 0
test_nufw  $admin  $pedago        195    -      0 - -
echo
